// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v3.6.1
// source: routeguide/institutions.proto

package routeguide

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// InstitutionClient is the client API for Institution service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type InstitutionClient interface {
	GetFeaturee(ctx context.Context, in *Pointt, opts ...grpc.CallOption) (*Featuree, error)
	ListFeaturees(ctx context.Context, in *Rectanglee, opts ...grpc.CallOption) (Institution_ListFeatureesClient, error)
	RecordRoute(ctx context.Context, opts ...grpc.CallOption) (Institution_RecordRouteClient, error)
	RouteChat(ctx context.Context, opts ...grpc.CallOption) (Institution_RouteChatClient, error)
}

type institutionClient struct {
	cc grpc.ClientConnInterface
}

func NewInstitutionClient(cc grpc.ClientConnInterface) InstitutionClient {
	return &institutionClient{cc}
}

func (c *institutionClient) GetFeaturee(ctx context.Context, in *Pointt, opts ...grpc.CallOption) (*Featuree, error) {
	out := new(Featuree)
	err := c.cc.Invoke(ctx, "/routeguide.Institution/GetFeaturee", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *institutionClient) ListFeaturees(ctx context.Context, in *Rectanglee, opts ...grpc.CallOption) (Institution_ListFeatureesClient, error) {
	stream, err := c.cc.NewStream(ctx, &Institution_ServiceDesc.Streams[0], "/routeguide.Institution/ListFeaturees", opts...)
	if err != nil {
		return nil, err
	}
	x := &institutionListFeatureesClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Institution_ListFeatureesClient interface {
	Recv() (*Featuree, error)
	grpc.ClientStream
}

type institutionListFeatureesClient struct {
	grpc.ClientStream
}

func (x *institutionListFeatureesClient) Recv() (*Featuree, error) {
	m := new(Featuree)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *institutionClient) RecordRoute(ctx context.Context, opts ...grpc.CallOption) (Institution_RecordRouteClient, error) {
	stream, err := c.cc.NewStream(ctx, &Institution_ServiceDesc.Streams[1], "/routeguide.Institution/RecordRoute", opts...)
	if err != nil {
		return nil, err
	}
	x := &institutionRecordRouteClient{stream}
	return x, nil
}

type Institution_RecordRouteClient interface {
	Send(*Pointt) error
	CloseAndRecv() (*RouteSummaryy, error)
	grpc.ClientStream
}

type institutionRecordRouteClient struct {
	grpc.ClientStream
}

func (x *institutionRecordRouteClient) Send(m *Pointt) error {
	return x.ClientStream.SendMsg(m)
}

func (x *institutionRecordRouteClient) CloseAndRecv() (*RouteSummaryy, error) {
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	m := new(RouteSummaryy)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *institutionClient) RouteChat(ctx context.Context, opts ...grpc.CallOption) (Institution_RouteChatClient, error) {
	stream, err := c.cc.NewStream(ctx, &Institution_ServiceDesc.Streams[2], "/routeguide.Institution/RouteChat", opts...)
	if err != nil {
		return nil, err
	}
	x := &institutionRouteChatClient{stream}
	return x, nil
}

type Institution_RouteChatClient interface {
	Send(*RouteNotee) error
	Recv() (*RouteNotee, error)
	grpc.ClientStream
}

type institutionRouteChatClient struct {
	grpc.ClientStream
}

func (x *institutionRouteChatClient) Send(m *RouteNotee) error {
	return x.ClientStream.SendMsg(m)
}

func (x *institutionRouteChatClient) Recv() (*RouteNotee, error) {
	m := new(RouteNotee)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// InstitutionServer is the server API for Institution service.
// All implementations must embed UnimplementedInstitutionServer
// for forward compatibility
type InstitutionServer interface {
	GetFeaturee(context.Context, *Pointt) (*Featuree, error)
	ListFeaturees(*Rectanglee, Institution_ListFeatureesServer) error
	RecordRoute(Institution_RecordRouteServer) error
	RouteChat(Institution_RouteChatServer) error
	mustEmbedUnimplementedInstitutionServer()
}

// UnimplementedInstitutionServer must be embedded to have forward compatible implementations.
type UnimplementedInstitutionServer struct {
}

func (UnimplementedInstitutionServer) GetFeaturee(context.Context, *Pointt) (*Featuree, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetFeaturee not implemented")
}
func (UnimplementedInstitutionServer) ListFeaturees(*Rectanglee, Institution_ListFeatureesServer) error {
	return status.Errorf(codes.Unimplemented, "method ListFeaturees not implemented")
}
func (UnimplementedInstitutionServer) RecordRoute(Institution_RecordRouteServer) error {
	return status.Errorf(codes.Unimplemented, "method RecordRoute not implemented")
}
func (UnimplementedInstitutionServer) RouteChat(Institution_RouteChatServer) error {
	return status.Errorf(codes.Unimplemented, "method RouteChat not implemented")
}
func (UnimplementedInstitutionServer) mustEmbedUnimplementedInstitutionServer() {}

// UnsafeInstitutionServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to InstitutionServer will
// result in compilation errors.
type UnsafeInstitutionServer interface {
	mustEmbedUnimplementedInstitutionServer()
}

func RegisterInstitutionServer(s grpc.ServiceRegistrar, srv InstitutionServer) {
	s.RegisterService(&Institution_ServiceDesc, srv)
}

func _Institution_GetFeaturee_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Pointt)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(InstitutionServer).GetFeaturee(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/routeguide.Institution/GetFeaturee",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(InstitutionServer).GetFeaturee(ctx, req.(*Pointt))
	}
	return interceptor(ctx, in, info, handler)
}

func _Institution_ListFeaturees_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(Rectanglee)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(InstitutionServer).ListFeaturees(m, &institutionListFeatureesServer{stream})
}

type Institution_ListFeatureesServer interface {
	Send(*Featuree) error
	grpc.ServerStream
}

type institutionListFeatureesServer struct {
	grpc.ServerStream
}

func (x *institutionListFeatureesServer) Send(m *Featuree) error {
	return x.ServerStream.SendMsg(m)
}

func _Institution_RecordRoute_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(InstitutionServer).RecordRoute(&institutionRecordRouteServer{stream})
}

type Institution_RecordRouteServer interface {
	SendAndClose(*RouteSummaryy) error
	Recv() (*Pointt, error)
	grpc.ServerStream
}

type institutionRecordRouteServer struct {
	grpc.ServerStream
}

func (x *institutionRecordRouteServer) SendAndClose(m *RouteSummaryy) error {
	return x.ServerStream.SendMsg(m)
}

func (x *institutionRecordRouteServer) Recv() (*Pointt, error) {
	m := new(Pointt)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _Institution_RouteChat_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(InstitutionServer).RouteChat(&institutionRouteChatServer{stream})
}

type Institution_RouteChatServer interface {
	Send(*RouteNotee) error
	Recv() (*RouteNotee, error)
	grpc.ServerStream
}

type institutionRouteChatServer struct {
	grpc.ServerStream
}

func (x *institutionRouteChatServer) Send(m *RouteNotee) error {
	return x.ServerStream.SendMsg(m)
}

func (x *institutionRouteChatServer) Recv() (*RouteNotee, error) {
	m := new(RouteNotee)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// Institution_ServiceDesc is the grpc.ServiceDesc for Institution service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Institution_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "routeguide.Institution",
	HandlerType: (*InstitutionServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetFeaturee",
			Handler:    _Institution_GetFeaturee_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "ListFeaturees",
			Handler:       _Institution_ListFeaturees_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "RecordRoute",
			Handler:       _Institution_RecordRoute_Handler,
			ClientStreams: true,
		},
		{
			StreamName:    "RouteChat",
			Handler:       _Institution_RouteChat_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
	},
	Metadata: "routeguide/institutions.proto",
}
